<?php
	/*
	Copyright (C) 2002-2004 Edwin van Wijk, www.v-wijk.net

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	New in Version 3.2
	- Replaced short tags with full php tags
	- Fixed wrong directory indication
	- Fixed problem with editing HTML files (doubling of slashes)
	- Added translation files
	  - Norwegian
	  - Swedish
	  - Turkish	
	  - Ukrainian
	*/

	include('config.inc.php'); //load configuration
	$currentVersion = "3.2";

	// Report simple running errors
	//error_reporting(E_ERROR | E_WARNING | E_PARSE);
	error_reporting(E_ERROR | E_PARSE);

	//Procedure for emptying the tmp directory
	if($clearTemp==true)
	{
		if ($handle = opendir($downloadDir)) {
			while (false !== ($delFile = readdir($handle))) {
				if($delFile!="." and $delFile!="..") {
					unlink($downloadDir . $delFile);
				}
			}
			closedir($handle);
		}
	}


	include("include/functions.inc.php");

	session_start();

	// Get the POST, GET and SESSION variables (if register_globals=off (PHP4.2.1+))
	// It's a bit of a dirty hack but variables are sometimes GET and sometimes POST variables
	$goPassive=(isset($_POST['goPassive']))?$_POST['goPassive']:$_GET['goPassive'];
	$mode=(isset($_POST['mode']))?$_POST['mode']:$_GET['mode'];
	$actionType=(isset($_POST['actionType']))?$_POST['actionType']:$_GET['actionType'];
	$currentDir=(isset($_POST['currentDir']))?$_POST['currentDir']:$_GET['currentDir'];
	$file=(isset($_POST['file']))?$_POST['file']:$_GET['file'];
	$file2=(isset($_POST['file2']))?$_POST['file2']:$_GET['file2'];
	$permissions=(isset($_POST['permissions']))?$_POST['permissions']:$_GET['permissions'];
	$directory=(isset($_POST['directory']))?$_POST['directory']:$_GET['directory'];
	$fname=(isset($_POST['fname']))?$_POST['fname']:$_GET['fname'];
	$fileContent=(isset($_POST['fileContent']))?$_POST['fileContent']:$_GET['fileContent'];
	$MAX_FILE_SIZE=(isset($_POST['MAX_FILE_SIZE']))?$_POST['MAX_FILE_SIZE']:$_GET['MAX_FILE_SIZE'];

	$currentDir=StripSlashes($currentDir);
	$file=StripSlashes($file);
	$file2=StripSlashes($file2);

	if(isset($_POST['user'])) {
		// we dont care if we are already logged or not in case user provides
		// login information. That allows relogging in without explicitly
		// loging out, eg with the "back" button.
		if ($editDefaultServer)
			$_SESSION['server']=$_POST['server'];
		else
			$_SESSION['server']=$defaultServer;

		$_SESSION['user']=$_POST['user'];
		$_SESSION['password']=$_POST['password'];
		$_SESSION['language']=$_POST['language'];
		$_SESSION['port']=$_POST['port'];
	}


	if ($actionType=="logoff")
	{
		unset($_SESSION['server']);
		unset($_SESSION['user']);
		unset($_SESSION['password']);
		unset($_SESSION['port']);

		session_destroy();
	}

	$server=$_SESSION['server'];
	$user=$_SESSION['user'];
	$password=$_SESSION['password'];
	$language=$_SESSION['language'];
	$port=$_SESSION['port'];


	// If language is not yet set, check the default language or try to get the language from your browser.
	if($language==""){
		if ($defaultLanguage !="") {
			$language = $defaultLanguage ;
		} else {
			$browser_lang = getenv("http_accept_language");
			$tmplang = $languages[$browser_lang];
			if(file_exists("include/language/" . $tmplang . ".lang.php")) {
				$language = $tmplang;
			} else {
				$language = "english";
			}
		}
	}

	//Include Language file
	include("include/language/" . $language . ".lang.php");   // Selected language

	if ($server!="")
	{
		$connection = @ftp_connect($server, $port);
		$loggedOn = @ftp_login($connection, $user, $password);
		$systype = @ftp_systype($connection);
		if($goPassive) {
			$passiveMode = @ftp_pasv($connection, true);
		}

		if(!isset($mode))
		{
			$mode=1; //(FTP_ASCII = 0; FTP_BINARY=1)
		}
		if ($loggedOn)
		{
			if (isset($currentDir))
			{
				ftp_chdir($connection, $currentDir);
			}
			$currentDir = ftp_pwd($connection);
			$msg = currentDirectory($currentDir);
			// what to do now ???
			if(isset($actionType)) {
				switch ($actionType) {
					case "chmod":	// Change permissions
						if(@ftp_site($connection, "chmod $permissions $file"))
						{
							$msg= $lblFilePermissionChanged;
						} else
						{
							$msg= $lblCouldNotChangePermissions;
						}
						break;
					case "cd":			// Change directory
						 //First try : normal directory
						 if ($file=="..")
						 {
							@ftp_cdup($connection);
							$currentDir = @ftp_pwd($connection);
							$msg = 	$lblIndexOf . " " . currentDirectory($currentDir);
						 }
						 else
                         {
						 if(@ftp_chdir($connection, $currentDir . $file))
						 {
							$currentDir = @ftp_pwd($connection);
							$msg = $lblIndexOf . " " . currentDirectory($currentDir);
						 }
						 elseif(@ftp_chdir($connection, $file)) // Symbolic link directory
						 {
							$currentDir = @ftp_pwd($connection);
							$msg = $lblIndexOf . " " . currentDirectory($currentDir);
						 }
						 else // link to a file so let's retrieve this...
						 {
							header("Content-disposition: attachment; filename=\"$file\"");
							header("Content-type: application/octetstream");
							header("Pragma: ");
							header("Cache-Control: cache");
							header("Expires: 0");

							//Determine original filename
							$filearray = explode("/",$file);
							$file = $filearray[sizeof($filearray)-1];
							$msg = $file;

							$fp = fopen($downloadDir . $file, "w");
							if(!@ftp_fget($connection,$fp,"$file",$mode))
							{
								fclose($fp);
								exit;
							}
							fclose($fp);
							$data = readfile($downloadDir . $file);
							$i=0;
							while ($data[$i] != "")
							{
								echo $data[$i];
								$i++;
							}
							unlink($downloadDir . $file);
							exit;
                          }
						}
						break;
					case "edit":
						//First download the file to the server
						$fp = fopen($downloadDir . $file, "w");
						ftp_fget($connection,$fp,"$file",$mode) OR DIE($lblErrorDownloadingFile);
						fclose($fp);

						//Now open the content of the file in an edit window
					?>
						<html>
						<HEAD>
							<TITLE>phpWebFTP <?php echo $currentVersion;?> By Edwin van Wijk</TITLE>
							<LINK REL=StyleSheet HREF="style/cm.css" TITLE=Contemporary TYPE="text/css">
							<SCRIPT LANGUAGE="JavaScript" SRC="include/script.js"></SCRIPT>
						</HEAD>
						<body>
						<h2>Edit <?php echo $file;?></h2>
						<FORM METHOD=POST NAME='editFileForm' ACTION="<?php echo $php_self;?>">
							<INPUT TYPE='hidden' NAME='actionType' VALUE='saveFile'>
							<INPUT TYPE='hidden' NAME='currentDir' VALUE='<?php echo $currentDir;?>'>
							<INPUT TYPE='hidden' NAME='file' VALUE='<?php echo $file;?>'>
							<INPUT TYPE='hidden' NAME='mode' VALUE='<?php echo $mode;?>'>
							<TEXTAREA NAME="fileContent" ROWS='30' COLS='80'><?php $data = stripslashes(readfile($downloadDir . $file));?></TEXTAREA>
							<br>
							<INPUT TYPE="submit" value="save"><INPUT TYPE=button OnClick='cancelEditFile();' VALUE="cancel" >
						</FORM>
						</body>
						</html>
					<?php
						unlink($downloadDir . $file);
						exit;
						break;
					case "saveFile":
						//Write content of fileContent to tempFile
						$tempFile = "tmpFile.txt";
						$fp = fopen($downloadDir . $tempFile, "w+t");
						if ($bytes=!fwrite($fp, stripslashes($fileContent))) {
						   $msg = $lblFileCouldNotBeUploaded;
						}
						fclose($fp);

						//Upload the file to the server
						if(!ftp_put($connection, $currentDir . "/" . filePart(StripSlashes($file)), $downloadDir . $tempFile, $mode)) {
						   $msg = $lblFileCouldNotBeUploaded;
						}
						unlink($downloadDir . $tempFile);
						break;

					case "get":			// Download file
						header("Content-disposition: attachment; filename=\"$file\"");
						header("Content-type: application/octetstream");
						header("Pragma: ");
						header("Cache-Control: cache");
						header("Expires: 0");

						// If resume download is on (see config.inc.php), use this functionality
						if($resumeDownload) {
							$fp = fopen($downloadDir . $file, "a+");
							ftp_fget($connection,$fp,"$file",$mode, filesize($downloadDir . $file)) OR DIE($lblErrorDownloadingFile);
						} else {
							$fp = fopen($downloadDir . $file, "w");
							ftp_fget($connection,$fp,"$file",$mode) OR DIE($lblErrorDownloadingFile);
						}

						fclose($fp);
						$data = readfile($downloadDir . $file);
						$i=0;
						while ($data[$i] != "")
						{
							echo $data[$i];
							$i++;
						}
						unlink($downloadDir . $file);
						exit;
						break;
					case "put":			// Upload file
						if($HTTP_POST_FILES['file']['size'] > $MAX_FILE_SIZE)
						{
							$msg = "<B>" . $lblFileSizeTooBig . "</B> (max. " . $MAX_FILE_SIZE . "bytes)<P>";
						}
						else
						{
							if(file_exists($HTTP_POST_FILES['file']['tmp_name']))
							{
								ftp_put($connection, $currentDir . "/" . filePart(StripSlashes($fname)), $HTTP_POST_FILES['file']['tmp_name'], $mode);
								unlink($HTTP_POST_FILES['file']['tmp_name']);
							}
							else
							{
								$msg = $lblFileCouldNotBeUploaded;
							}
						}
						break;
					case "deldir";		// Delete directory
						if(@ftp_rmdir($connection, "$file"))
						{
								$msg = "$file " . $lblDeleted;
						}
						else
						{
							//Verify if has files inside and if so, call recursive del
							if ($lista = @ftp_nlist($connection, "$currentDir/$file")){
								del_recursive($currentDir,$connection,$file);
								$msg = "$file " . $lblDeleted;
							}
							else $msg = $lblCouldNotDelete . " " . $file;
						}
						break;
					case "delfile";		// Delete file
						if(@ftp_delete($connection, "$file"))
						{
							$msg = "$file " . $lblDeleted;
						} else { // Delete the directory
							if(@ftp_rmdir($connection, "$file"))
							{
									$msg = "$file " . $lblDeleted;
							} else { // Recursivly delete the directory
								//Verify if has files inside and if so, call recursive del
								if ($lista = @ftp_nlist($connection, "$currentDir/$file")){
									del_recursive($currentDir,$connection,$file);
									$msg = "$file " . $lblDeleted;
								}
								else $msg = $lblCouldNotDelete . " " . $file;
							}
						}
						break;
					case "rename";		// Rename file
						if(@ftp_rename($connection, "$file", "$file2"))
						{
							$msg = $file . " " . $lblRenamedTo . " " . $file2;
						}
						else
						{
							$msg = $lblCouldNotRename . " " . $file . " " . $lblTo . " " . $file2;
						}
						break;
					case "createdir":  // Create a new directory
						if(@ftp_mkdir($connection, "$file"))
						{
							$msg = $file . " " . $lblCreated;
						}
						else
						{
							$msg = $lblCouldNotCreate . " " . $file;
						}
						break;
				}
			}
?>
<HTML>
<HEAD>
	<TITLE>phpWebFTP <?php echo $currentVersion;?> By Edwin van Wijk</TITLE>
	<LINK REL=StyleSheet HREF="style/cm.css" TITLE=Contemporary TYPE="text/css">
	<SCRIPT LANGUAGE="JavaScript" SRC="include/script.js"></SCRIPT>
</HEAD>
<BODY>
<TABLE CELLPADDING=0 CELLSPACING=0 HEIGHT="100%">
<TR><TD>
	<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%'>
		<TR>
			<TD CLASS=titlebar COLSPAN=3>
				<B>phpWebFTP <?php echo $lblVersion;?> <?php echo $currentVersion;?></B>
			</TD>
		</TR>
		<TR>
			<TD CLASS=menu>
			<?php
			$newMode=($mode==1)?0:1;
			?>
				<?php if($loggedOn) { ?>
				<TABLE CELLPADDING=0 CELLSPACING=0><TR>

				<TD VALIGN=CENTER>&nbsp;<A HREF='javascript:submitForm("cd","..")'><IMG SRC="img/parent.gif" HEIGHT=24 WIDTH=24 ALIGN=TOP BORDER=0></A></TD>
				<TD VALIGN=CENTER><nobr><A HREF='javascript:submitForm("cd","..")'>&nbsp;<?php echo $lblUp;?></A> </nobr></TD>

				<TD VALIGN=CENTER>&nbsp;<A CLASS=menu HREF="javascript:changeMode('<?php echo $newMode;?>')"><IMG SRC="img/mode.gif" HEIGHT=24 BORDER=0 ALIGN=CENTER></A></TD>
				<TD VALIGN=CENTER><nobr><A CLASS=menu HREF="javascript:changeMode('<?php echo $newMode;?>')">&nbsp;<?php echo $lblChangeMode;?></A> </nobr></TD>

				<TD VALIGN=CENTER>&nbsp;<A CLASS=menu HREF="javascript:logOff()"><IMG SRC="img/logoff.gif" HEIGHT=24 BORDER=0 ALIGN=CENTER></A></TD>
				<TD VALIGN=CENTER><nobr><A CLASS=menu HREF="javascript:logOff()">&nbsp;<?php echo $lblLogOff;?></A> </nobr></TD>

				<TD COLSPAN=6 VALIGN=TOP class=statusbar width="100%" VALIGN=CENTER ALIGN=RIGHT>
					<?php echo directoryPath($currentDir, $server);?>
				</TD>
				</TR>
</TABLE>
				<?php } else { ?>
				<TABLE CELLPADDING=0 CELLSPACING=0><TR>
				<TD VALIGN=CENTER>&nbsp;<A CLASS=menu HREF="javascript:logOff()"><IMG SRC="img/logoff.gif" HEIGHT=24 BORDER=0 ALIGN=CENTER></A> </TD>
				<TD VALIGN=CENTER>&nbsp;<A CLASS=menu HREF="javascript:logOff()"><?php echo $lblRetry;?></A> </TD>
				</TR></TABLE>

				<?php } ?>
			</TD>
			</FORM>
		</TR>
	</TABLE>
</TD></TR>
<TR><TD HEIGHT="100%">
	<FORM NAME="actionform" METHOD=POST ACTION='<?php echo $PHP_SELF;?>'>
		<INPUT TYPE='hidden' NAME='actionType' VALUE=''>
		<INPUT TYPE='hidden' NAME='currentDir' VALUE='<?php echo $currentDir;?>'>
		<INPUT TYPE='hidden' NAME='file' VALUE=''>
		<INPUT TYPE='hidden' NAME='file2' VALUE=''>
		<INPUT TYPE='hidden' NAME='extension' VALUE=''>
		<INPUT TYPE='hidden' NAME='permissions' VALUE=''>
		<INPUT TYPE='hidden' NAME='mode' VALUE='<?php echo $mode;?>' STYLE='border: none; background-color: #EFEFEF;'>
	</FORM>
	<HR>

	<TABLE HEIGHT="100%">
		<TR>
		<TD class=leftmenu VALIGN=TOP width=210>
			<DIV ALIGN=CENTER>
				<BR>
				<!-- File and folder -->
				<TABLE CELLPADDING=0 CELLSPACING=0 class=item>
					<TR>
						<TD VALIGN=TOP class=itemhead>
							<B><?php echo $lblFileTasks;?></B>
						</TD>
						</FORM>
					</TR>
					<TR>
						<TD VALIGN=TOP class=leftmenuitem>

							<DIV id="fileactions" style='display:none;'>
							<TABLE>
								<!-- Delete File -->
								<TR>
									<TD VALIGN=CENTER><IMG SRC="img/menu_delete.gif"></TD>
									<TD VALIGN=CENTER>
										<A HREF='javascript:deleteFile()' class=leftmenulink><?php echo $lblDeleteFile;?></A>
									</TD>
								</TR>

								<TR>
									<TD VALIGN=CENTER><IMG SRC="img/menu_edit.gif"></TD>
									<TD VALIGN=CENTER>
										<A HREF='javascript:editFile()' class=leftmenulink><?php echo $lblEditFile;?></A>
									</TD>
								</TR>

								<TR>
									<TD VALIGN=top><IMG SRC="img/menu_rename.gif"></TD>
									<TD VALIGN=top>
										<A HREF='javascript:setNewFileName("<?php echo $myDir["name"];?>")' class=leftmenulink><?php echo $lblRename;?></A>
										<!-- Rename file -->
										<DIV ID='renameFileEntry' style='display:none;'>
											<FORM NAME=renameFile>
											<TABLE CELLSPACING=0 class=lined align=center>
												<TR>
													<TD class=tinyblue>
													<B><?php echo $lblNewName;?></B><BR>
													<INPUT TYPE="text" NAME="newName" value=""></TD>
												</TR>
												</TABLE>
											<BR>
											<DIV ALIGN=CENTER><INPUT TYPE=button OnClick='renameItem();' VALUE='<?php echo $lblRename;?>'></DIV>
											</FORM>
											<BR>
										</DIV>
									</TD>
								</TR>

								<TR>
									<TD VALIGN=top><IMG SRC="img/menu_settings.gif"></TD>
									<TD VALIGN=top>
										<A HREF='javascript:;' OnClick='setPermissions()' class=leftmenulink><?php echo $lblSetPermissions;?></A>
										<!-- Change permissions -->
										<DIV ID='setPermissions' style='display:none;'>
											<FORM NAME=permissions>
											<TABLE CELLSPACING=0 class=lined align=center>
											<TR>
												<TD class=tinyblue ALIGN=CENTER><B><?php echo $lblOwner;?></B></TD>
												<TD class=tiny ALIGN=CENTER><B><?php echo $lblGroup;?></B></TD>
												<TD class=tinywhite ALIGN=CENTER><B><?php echo $lblPublic;?></B></TD>
											</TR>
											<TR>
												<TD class=tinyblue><INPUT TYPE="checkbox" NAME="iOr"> <?php echo $lblRead;?></TD>
												<TD class=tiny><INPUT TYPE="checkbox" NAME="iGr"> <?php echo $lblRead;?></TD>
												<TD class=tinywhite><INPUT TYPE="checkbox" NAME="iPr"> <?php echo $lblRead;?></TD>
											</TR>
											<TR>
												<TD class=tinyblue><INPUT TYPE="checkbox" NAME="iOw"> <?php echo $lblWrite;?></TD>
												<TD class=tiny><INPUT TYPE="checkbox" NAME="iGw"> <?php echo $lblWrite;?></TD>
												<TD class=tinywhite><INPUT TYPE="checkbox" NAME="iPw"> <?php echo $lblWrite;?></TD>
											</TR>
											<TR>
												<TD class=tinyblue><INPUT TYPE="checkbox" NAME="iOx"> <?php echo $lblExecute;?></TD>
												<TD class=tiny><INPUT TYPE="checkbox" NAME="iGx"> <?php echo $lblExecute;?></TD>
												<TD class=tinywhite><INPUT TYPE="checkbox" NAME="iPx"> <?php echo $lblExecute;?></TD>
											</TR>

											</TABLE>
											<BR>
											<DIV ALIGN=CENTER><INPUT TYPE=button OnClick='changePermissions()' VALUE='<?php echo $lblSetPermissions;?>'></DIV>
											</FORM>
											<BR>
										</DIV>
									</TD>
								</TR>
							</TABLE>
							</DIV>


							<!-- Standaard actions -->
							<TABLE>
								<TR>
									<TD VALIGN=top><IMG SRC="img/upload.gif" BORDER="0" ALT=""></TD>
									<TD VALIGN=top>
										<A HREF="JavaScript:toggle('uploadform');" class=leftmenulink><?php echo $lblUploadFile;?></A>
											<FORM id="uploadform" style='display:none;' NAME='putForm' ENCTYPE="multipart/form-data" METHOD=POST ACTION="<?php echo $PHP_SELF;?>" onsubmit="return validate()">
												<INPUT TYPE="hidden" NAME="actionType" VALUE="put">
												<input type="hidden" name="fname">
												<INPUT TYPE='hidden' NAME='currentDir' VALUE='<?php echo $currentDir;?>'>
												<INPUT TYPE="hidden" NAME="MAX_FILE_SIZE" VALUE="<?php echo $maxFileSize;?>">
												<INPUT TYPE='hidden' NAME='mode' VALUE='<?php echo $mode;?>'>
												<INPUT TYPE="file" NAME="file" STYLE="width:150px; font-size:7pt;"><BR>
												<INPUT TYPE="SUBMIT" VALUE="OK" STYLE='width=150px; font-size:7pt;'>
											</FORM>
									</TD>
								</TR>
								<TR>
									<TD VALIGN=top><IMG SRC="img/createdir.gif" BORDER="0" ALT=""></TD>
									<TD VALIGN=top>
										<A HREF="JavaScript:toggle('createform');" class=leftmenulink><?php echo $lblCreateDirectory;?></A>
										<FORM id="createform" style='display:none;' METHOD=POST NAME='dirinput' ACTION="<?php echo $PHP_SELF;?>">
											<INPUT TYPE="text" NAME="directory" VALUE="" STYLE="width:100px; font-size:7pt;">
											<INPUT TYPE="BUTTON" VALUE="OK" OnClick='javascript:createDirectory(dirinput.directory.value)' STYLE="width:40px; font-size:7pt;">
										</FORM>
									</TD>
								</TR>
								<TR>
									<TD VALIGN=top><IMG SRC="img/gotodir.gif" BORDER="0" ALT=""></TD>
									<TD VALIGN=top>
										<A HREF="JavaScript:toggle('gotoform');" class=leftmenulink><?php echo $lblGoToDirectory;?></A>
										<FORM id="gotoform" style='display:none;' NAME='cdDirect' METHOD=POST ACTION='<?php echo $PHP_SELF;?>'>
											<INPUT TYPE='hidden' NAME='actionType' VALUE='cd'>
											<INPUT TYPE='hidden' NAME='currentDir' VALUE='<?php echo $currentDir;?>'>
											<INPUT TYPE="text" NAME="file" VALUE="" STYLE="width:100px; font-size:7pt;">
											<INPUT TYPE="SUBMIT" VALUE="OK" STYLE="width:40px; font-size:7pt;">
										</FORM>
									</TD>
								</TR>
							</TABLE>
						</TD>
					</TR>
				</TABLE>
				<P>
				<!-- Details -->
				<TABLE CELLPADDING=0 CELLSPACING=0 class=item>
					<TR>
						<TD VALIGN=TOP class=itemhead>
							<B><?php echo $lblDetails;?></B>
						</TD>
						</FORM>
					</TR>
					<TR>
						<TD VALIGN=TOP class=leftmenuitem style='color:black' >
							<BR>
							<B><?php echo $msg;?></B>
							<P>
							<?php echo ($loggedOn)?"$lblConnectedTo  $server:$port ($systype)":$lblNotConnected;?>
							<P>
							<?php echo $lblTransferMode;?> :<?php echo $mode==1?$lblBinaryMode:$lblASCIIMode;?>
							<BR><BR>
						</TD>
					</TR>

				</TABLE>

			</DIV>
		</TD>
		<TD VALIGN=TOP>

			<P>
			<?php
				$list=Array();
				$list=ftp_rawlist($connection, "");
			?>
			<TABLE WIDTH="650" CELLSPACING=0 CELLPADDING=0 onClick='resetEntries()'>
				<TR>
					<TD COLSPAN=2 class=listhead><?php echo $lblName;?></TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead align=right><?php echo $lblSize;?>&nbsp;</TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead><?php echo $lblFileType;?>&nbsp;</TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead><?php echo $lblDate;?></TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead><?php echo $lblPermissions;?></TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead><?php echo $lblOwner;?></TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
					<TD class=listhead><?php echo $lblGroup;?></TD>
					<TD class=listhead><IMG SRC="img/listheaddiv.gif"></TD>
				</TR>
	 		<?php
				$list = parse_ftp_rawlist($list, $systype);

				if (is_array($list))
				{
					// Directories
					$counter=0;
					foreach($list as $myDir)
					{
						if ($myDir["is_dir"]==1)
						{
							$fileAction = "cd";
							$fileName = $myDir["name"];
							$fileSize="";
							$delAction = "deldir";
							$fileType['description'] = 'File Folder';
							$fileType['imgfilename'] = 'folder.gif';
						}

						if ($myDir["is_link"]==1)
						{
							$fileAction = "cd";
							$fileName = $myDir["target"];
							$fileSize="";
							$delAction = "delfile";
							$fileType['description'] = 'Symbolic Link';
							$fileType['imgfilename'] = 'link.gif';
						}

						if ($myDir["is_link"]!=1 && $myDir["is_dir"]!=1)
						{
						    $fileType = fileDescription($myDir["name"]);
							$fileAction = "get";
							$fileName = $myDir["name"];
							$image = "file.gif";
							if($myDir["size"]<1024) {
								$fileSize= $myDir["size"] . " bytes ";
									$fileSize=number_format($myDir["size"], 0, ',', '.') . " bytes";
							} else {
								if($myDir["size"]<1073741824) {
									$fileSize=number_format($myDir["size"]/1024, 0, ',', '.') . " KB";
								} else {
									$fileSize=number_format($myDir["size"]/1048576, 0, ',', '.') . " MB";
								}
							}

							
							$delAction = "delfile";
						}
				?>

							<TR>
							<TD class=filenamecol width=20><A HREF='javascript:selectEntry("<?php echo $fileAction;?>","<?php echo $fileName;?>","filename<?php echo $counter;?>","<?php echo $myDir["perms"];?>")' ondblclick='submitForm("<?php echo $fileAction;?>","<?php echo $fileName;?>")'><IMG SRC="img/<?php echo $fileType['imgfilename'];?>" ALIGN=TOP BORDER=0></A></TD>
							<TD class=filenamecol><span id='filename<?php echo $counter;?>'><A HREF='javascript:selectEntry("<?php echo $fileAction;?>","<?php echo $fileName;?>","filename<?php echo $counter;?>","<?php echo $myDir["perms"];?>")' ondblclick='submitForm("<?php echo $fileAction;?>","<?php echo $fileName;?>")'><?php echo $fileName;?></A></span></TD>
							<TD>&nbsp;</TD>
							<TD ALIGN=RIGHT><?php echo $fileSize;?></TD>
							<TD>&nbsp;</TD>
							<TD ALIGN=left><?php echo $fileType['description'];?></TD>
							<TD>&nbsp;</TD>
							<TD><?php echo $myDir["date"];?></TD>
							<TD>&nbsp;</TD>
							<TD><?php echo $myDir["perms"];?></TD>
							<TD>&nbsp;</TD>
							<TD><?php echo $myDir["user"];?></TD>
							<TD>&nbsp;</TD>
							<TD><?php echo $myDir["group"];?></TD>
							<TD>&nbsp;</TD>
							</TR>
				<?php
						$counter++;
					}
				} else {
				?>
							<TR>
							<TD colspan=14><BR><B><?php echo $lblDirectoryEmpty;?>...</B></TD>
							</TR>
				<?php
				}
				print "	</TABLE></TD></TR></TABLE>";
			}
			else
			{
				if(!isset($msg))
				{
					$msg = "$lblCouldNotConnectToServer  $server:$port $lblWithUser $user<P><A HREF='" . $_SERVER["PHP_SELF"] . "'>$lblTryAgain</A>";
					unset($_SESSION['server']);
					unset($_SESSION['user']);
					unset($_SESSION['password']);
					unset($_SESSION['port']);
					session_destroy();
				}
	?>
</TD></TR></TABLE>
<HTML>
<HEAD>
	<TITLE>phpWebFTP <?php echo $currentVersion;?> By Edwin van Wijk</TITLE>
	<LINK REL=StyleSheet HREF="style/cm.css" TITLE=Contemporary TYPE="text/css">
	<SCRIPT LANGUAGE="JavaScript" SRC="include/script.js"></SCRIPT>
</HEAD>
<BODY>
<?php
			print $msg;
		}
	}
	else // Still need to logon...
	{
?>
<HTML>
<HEAD>
	<TITLE>phpWebFTP <?php echo $currentVersion;?> By Edwin van Wijk</TITLE>
	<LINK REL=StyleSheet HREF="style/cm.css" TITLE=Contemporary TYPE="text/css">
	<SCRIPT LANGUAGE="JavaScript" SRC="include/script.js"></SCRIPT>
</HEAD>
<BODY>
		<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%'>
			<TR>
				<TD CLASS=titlebar>
					<B>phpWebFTP <?php echo $lblVersion;?> <?php echo $currentVersion;?></B>
				</TD>
			</TR>
			<TR>
				<TD CLASS=menu>
					<TABLE CELLPADDING=0 CELLSPACING=0><TR>
					<TD VALIGN=CENTER><IMG SRC="img/1px.gif" HEIGHT=24 BORDER=0 ALIGN=CENTER></TD>
					<TD VALIGN=CENTER>&nbsp;</TD>
					</TR></TABLE>
				</TD>
			</TR>
		</TABLE>

		<FORM NAME=login action='<?php echo $_SERVER['PHP_SELF'];?>' METHOD=POST>
		<TABLE class=login cellpadding=3>
			<TR>
				<TD COLSPAN=3><B>&nbsp;<?php echo $lblLogIn;?></B></TD>
			</TR>
			<TR>
				<TD COLSPAN=3><IMG SRC="img/1px.gif" HEIGHT=60></TD>
			</TR>
			<TR>
				<TD COLSPAN=3>&nbsp;<?php echo $lblConnectToFTPServer;?></TD>
			</TR>
			<TR>
				<TD VALIGN=TOP>&nbsp;<?php echo $lblServer;?></TD>
				<TD VALIGN=TOP>
					<?php
						if($defaultServer == "") {
							print "<INPUT TYPE=TEXT NAME=server SIZE=15>&nbsp;";
						} else {
							$inputType=($editDefaultServer==true)?"TEXT":"HIDDEN";
							print "<INPUT TYPE=" . $inputType . " NAME=server VALUE=" . $defaultServer . ">";
							if($editDefaultServer==false) {
								print "<B>" . $defaultServer . "</B>&nbsp;";
							}
						}
					?>
				</TD>
				<TD VALIGN=TOP>
					<TABLE CELLSPACING=0>
						<TR>
							<TD><?php echo $lblPort;?></TD>
							<TD><INPUT TYPE=TEXT NAME=port SIZE=3 VALUE=21></TD>
						</TR>
						<TR>
							<TD><?php echo $lblPasive;?></TD>
							<TD><INPUT TYPE="checkbox" NAME="goPassive"></TD>
						</TR>
					</TABLE>
				</TD>
			</TR>
			<TR>
				<TD>&nbsp;<?php echo $lblUser;?></TD>
				<TD>
					<INPUT TYPE=TEXT NAME=user SIZE=18>
				</TD>
				<TD>&nbsp;</TD>
			</TR>
			<TR>
				<TD>&nbsp;<?php echo $lblPassword;?></TD>
				<TD><INPUT TYPE=PASSWORD NAME=password SIZE=18></TD>
				<TD><INPUT TYPE=SUBMIT VALUE="Log on"></TD>
			</TR>

			<?php
				if($defaultLanguage == "") {
			?>
			<TR>
				<TD>&nbsp;<?php echo $lblLanguage;?></TD>
				<TD colspan=2>
					<?php

					?>
					<SELECT NAME="language">
					<?php
						if ($handle = opendir('include/language/')) {
							//Read file in directory and store them in an Array
							while (false !== ($file = readdir($handle))) {
								$fileArray[$file] = $file;
							}
							//Sort the array
							ksort($fileArray);

							foreach($fileArray as $file) {
								if ($file != "." && $file != ".." ) {
								    $file=str_replace(".lang.php","",$file);
								    $counter=0;
								    foreach($languages as $thislang)
								    {
								        if($thislang==$file)
								        {
								            $counter++;
								        }
								    }
								    if($counter>0) {
										$langName=strtoupper(substr($file,0,1)) . substr($file,1);
					?>
										<OPTION VALUE="<?php echo $file;?>" <?php echo ($language==$file)?"selected":"";?>><?php echo $langName;?></OPTION>
					<?php
								    }

								}
							}
							closedir($handle);
						}
			 				?>
					</SELECT>
			</TR>
			<?php
				} // End default server
			?>
			<TR>
				<TD COLSPAN=2><IMG SRC="img/1px.gif" HEIGHT=5></TD>
			</TR>
		</TABLE>
		<TABLE WIDTH=328>
		<TR>
				<TD COLSPAN=2 VALIGN=TOP class=leftmenuitem>
					<DIV style='font-size:7pt;'>
					<?php echo $lblDisclaimer;?>
					<BR><BR>
					phpWebFTP <?php echo $lblVersion;?> <?php echo $currentVersion;?><BR>
					&copy; 2002-2004, Edwin van Wijk,<BR>
					<A HREF="http://www.v-wijk.net" style='font-size:7pt;'>www.v-wijk.net</A>
					</div>
					<P>
				</TD>
			</TR>
			<TR>
			<TD ALIGN=LEFT>&nbsp;</TD>
			<TD ALIGN=RIGHT>
				&nbsp;
			</TD>
			</TR>
		</TABLE>
		</FORM>
<?php
	}
?>
<P>
</BODY>
</HTML>
